id | str | "Llama-4-Maverick-17B-128E-Instruct-FP8" | The id of the Llama model to use |
name | str | "Llama" | The name of the model |
provider | str | "Llama" | The provider of the model |
max_completion_tokens | Optional[int] | None | Maximum number of tokens to generate |
repetition_penalty | Optional[float] | None | Penalty for repeating tokens (higher values reduce repetition) |
temperature | Optional[float] | None | Controls randomness in the model’s output |
top_p | Optional[float] | None | Controls diversity via nucleus sampling |
top_k | Optional[int] | None | Controls diversity via top-k sampling |
extra_headers | Optional[Any] | None | Additional headers for the request |
extra_query | Optional[Any] | None | Additional query parameters for the request |
extra_body | Optional[Any] | None | Additional body fields for the request |
request_params | Optional[Dict[str, Any]] | None | Additional parameters to include in the request |
api_key | Optional[str] | None | The API key for the Llama API (defaults to LLAMA_API_KEY env var) |
base_url | Optional[Union[str, httpx.URL]] | None | The base URL for the Llama API |
timeout | Optional[float] | None | Request timeout in seconds |
max_retries | Optional[int] | None | Maximum number of client retries for failed requests |
default_headers | Optional[Any] | None | Default headers for client requests |
default_query | Optional[Any] | None | Default query parameters for client requests |
http_client | Optional[Union[httpx.Client, httpx.AsyncClient]] | None | Custom HTTP client for requests |
client_params | Optional[Dict[str, Any]] | None | Additional parameters for client configuration |
client | Optional[LlamaAPIClient] | None | Pre-configured Llama API client |
async_client | Optional[AsyncLlamaAPIClient] | None | Pre-configured async Llama API client |
model_type | ModelType | ModelType.MODEL | Functional role of this model (MODEL, OUTPUT_MODEL, PARSER_MODEL). Set by the agent |
supports_native_structured_outputs | bool | False | Whether the model supports structured outputs natively |
supports_json_schema_outputs | bool | True | Whether the model uses JSON schema for structured outputs |
system_prompt | Optional[str] | None | System prompt from the model added to the agent |
instructions | Optional[List[str]] | None | Instructions from the model added to the agent |
tool_message_role | str | "tool" | Role of tool messages |
assistant_message_role | str | "assistant" | Role of assistant messages |
cache_response | bool | False | Cache model responses to avoid redundant API calls during development |
cache_ttl | Optional[int] | None | Time-to-live for cached responses, in seconds |
cache_dir | Optional[str] | None | Directory for the response cache. Defaults to ~/.agno/cache/model_responses |
retries | int | 0 | Number of retries to attempt before raising a ModelProviderError |
delay_between_retries | int | 1 | Delay between retries, in seconds |
exponential_backoff | bool | False | If True, the delay between retries is doubled each time |
retry_with_guidance | bool | True | Retry a failed model invocation once with a guidance message appended |
retry_with_guidance_limit | int | 1 | Number of times to retry the model invocation with guidance |